//RAMBO - A very stupid but very aggressive TurboRisk program
import Risk.Risk;
import Risk.Internals.Exceptions.*;
import Risk.Jugador.*;

/**
* Jugador Rambo. Traducci no exacta del Jugador Rambo que tenia TurboRisk
*/
public class Rambo extends Jugador{
  
  /*public Rambo(Risk r){
    World = r;
  }*/
  
  // Per evitar problemes al carregar aquesta classe dinamicament, assignem
  // a World un objecte de tipus Risk mitjanant aquest mtode i no en el constructor.
  // Es imprescindible cridar aquesta funci abans de fer s de la resta.
  public void assignWorld(Risk World){
    this.World = World;
  }
  
  public int Assignment() throws PDIdreta, NoExisteix {
    int T,ToTerritory;
    // find first free territory (a very stupid way to start the game!)
   ToTerritory=0;
   T=1;    
    do{
      if (World.TOwner(T)==0){
        ToTerritory=T;
      }
      T++;
    } while ((ToTerritory==0) && (T<43));
    return ToTerritory;
  }
  
public int Placement() throws PDIdreta, NoExisteix {
   int T,ToTerritory;
   double Ratio,MaxRatio;
  // reinforce territory with greatest ratio between total enemy armies and
  // own armies
   ToTerritory=0;
   MaxRatio=0;
   for(T=1;T<43;T++){
      if ((World.TIsMine(T)) && (World.TIsFront(T))){ // territory is mine and front
         Ratio = (World.TPressure(T) / World.TArmies(T));
         if (Ratio > MaxRatio){
            ToTerritory=T;
            MaxRatio=Ratio;
         }
      }
   }
   return ToTerritory;
}

public AttackResult Attack() throws PDIdreta, NoExisteix, JaExisteix {
   int T,EnemyT,EnemyA,FromTerritory,ToTerritory;
   double Ratio,MaxRatio;
   AttackResult Result;
 // perform attack with best chances; stop after 1 conquest;
   FromTerritory=0;
   ToTerritory=0;
   MaxRatio=0;
   for (T=0;T<43;T++){
     if ((World.TIsMine(T)) && (World.TIsFront(T)) && (World.TArmies(T)>1)){  // territory is mine and front and attack is possible
       EnemyT=World.TWeakestFront(T);
       EnemyA=World.TWeakestFrontArmy(T);
       Ratio=World.TArmies(T) / EnemyA;
       if (Ratio>MaxRatio){
         FromTerritory=T;
         ToTerritory=EnemyT;
         MaxRatio=Ratio;
       }
     }
   }
  if (MaxRatio<1.5){    // suspend attacks when ratio too low
    FromTerritory=0;
  }
  Result = new AttackResult(FromTerritory,ToTerritory);
  return(Result);
}

public OccupaResult Occupation(AttackResult attacked) throws PDIdreta, NoExisteix {
   boolean FromIsFront,ToIsFront;
   int FromTerritory,ToTerritory,Armies;
   OccupaResult Result;
  // very simple but effective routine
   FromTerritory=attacked.GetFrom();
   ToTerritory=attacked.GetTo();

   FromIsFront = World.TIsFront(FromTerritory);
   ToIsFront = World.TIsFront(ToTerritory);
   Armies=0;
  // if both territories are 'front'
  if ((FromIsFront) && (ToIsFront)) {
    // balance armies
     Armies = (World.TArmies(FromTerritory)- World. TArmies(ToTerritory)) / 2;
  }
  // if "From" territory is front
  else if (FromIsFront){
    // all armies stay in From territory, so there's nothing to do
  }
  // in the other cases
  else{
    // all armies in the conquered territory (except one which must stay)
     Armies=World.TArmies(FromTerritory)-1;
  }
  Result = new OccupaResult(FromTerritory,ToTerritory,Armies);
  return (Result);
}

public OccupaResult Fortification() throws PDIdreta, NoExisteix {
   int T,B,MaxArmy,FromTerritory,ToTerritory, Armies;
   OccupaResult Result;

   FromTerritory=0;
   ToTerritory=0;
   Armies=0;

  // look for the greatest nuber of armies which is not on a front territory
   MaxArmy = 1;
   for(T=1;T<43;T++){
      if (World.TIsMine(T) && (! (World.TIsFront(T)))){ // territory is mine and not "front"
         if (World.TArmies(T) > MaxArmy){
            MaxArmy = World.TArmies(T);
            FromTerritory = T;
         }
      }
   }

  // if there are armies to move...
  if (FromTerritory > 0){
    // check if can move armies to front...
    for(B=1;B<=World.TBordersCount(FromTerritory);B++){
       if (ToTerritory==0){
          T = World.TBorder(FromTerritory,B);
          if (World.TIsMine(T) && World.TIsFront(T)){
             ToTerritory=T;
          }
       }
    }
    // otherwise move armies in the first bordering territory
    
    // El seguent codi en certes circumstancies pot produir un bucle infinit
    // es queda pasant armies de A a B i de B a A.
    /*if (ToTerritory==0){
       for(B=1;B<=World.TBordersCount(FromTerritory);B++){
          if (ToTerritory==0){
             T=World.TBorder(FromTerritory,B);
             if (World.TIsMine(T)){
                ToTerritory = T;
             }
          }
       }
    }*/
    // Move all armies to destination (except the one which must stay)
    if (ToTerritory > 0){
       Armies = World.TArmies(FromTerritory)-1;
    } else {
      FromTerritory = 0;
    }
  }
  Result = new OccupaResult(FromTerritory,ToTerritory,Armies);
  return Result;
}

}
