package Risk.Internals;

import Risk.Internals.Exceptions.*;

/**
* Element Continent que conte un llistat amb tots els altres continents amb els
* que fa frontera, una llista de tots el territoris que te, el seu nom i l'ID.
* A ms cont mtodes especial tils per porta a terme accions concretes de l'API
* que s'ha d'oferir als jugadors. 
*/
public class Continent {
  private Llista border;
  private Llista Territories;
  private String nom;
  private int id;

  protected Continent(String s, int id) throws NoMemoria {
    nom = s;
    border = new Llista();
    Territories = new Llista();
    this.id = id;
  }

  public int id(){
    return id;
  }

  public String nom(){
    return nom;
  }

  public void afegirTerritory(Territory t) throws PDIdreta, NoMemoria{
    Territories.anarAlFinal();
    Territories.insertar(t);
  }
  
  /**
  * Rertorna l'id del territori numero "num" que fa frontera amb aquest continent
  */
  public int Border(int num) throws PDIdreta {
    // indexTotal ens ayudara a trobar el territori numero "num"
    int indexTotal=1, index=1;
    Territory t, tFront;
    
    // Busquem per tota la llista de territoris
    Territories.principi();
    while (! Territories.finalLlista()) {
      t = (Territory)Territories.actual();
      // Del territori en el que ens trobem, mirem tots els que fan frontera amb
      // ell i no son del mateix continent
      tFront = t.SpecialBorder(index);
      while ( tFront != null) { // Si retorna null es que no hem sobrepassat el 
                                // nombre de territoris que te amb aquestes condicions
        index++;
        indexTotal++;
        if (indexTotal == num) {
          return tFront.id();
        }
        tFront = t.SpecialBorder(index);
      }
      Territories.avanzar();
      index=1;  // Anem a comprobar el seguent territori, inicialitzem a 1
                // pq mirarem pel nou territori TOTS els seus SpecialBorder
    }
    return 0;
  }
  
  public void borderWith(Continent c) throws PDIdreta, NoMemoria{
    border.anarAlFinal();
    border.insertar(c);
  }
  
  public boolean borderWith(String s) throws PDIdreta{
    Continent t;
    
    if (border.buida()) {
      return false;
    }
    
    border.principi();
    do {
      t = (Continent)border.actual();
      if (s.equals(t.nom())) {
        return true;
      }
      border.avanzar();
    } while (! (border.finalLlista()));
    
    return false;
  }
  
  /**
  * Rertorna el nombre de territoris que fan frontera amb aquest continent
  */
  public int BorderCount() throws PDIdreta {
    // indexTotal ens ayudara a trobar el territori numero "num"
    int indexTotal=1, index=1;
    Territory t;
    
    // Busquem per tota la llista de territoris
    Territories.principi();
    while (! Territories.finalLlista()) {
      t = (Territory)Territories.actual();
      // Del territori en el que ens trobem, mirem quants fan frontera amb
      // ell i no son del mateix continent. I ho afegim al total.
      indexTotal += t.SpecialBorderCount(); 
      Territories.avanzar();
    }
    return 0;
  }
  
  /**
  * @return Total de contients que fan frontera amb aquest
  */
  public int borderTotal() {
    return border.elements();
  }

  
}
