package Risk.Internals;

import Risk.Internals.Exceptions.*;

/**
* TAD Llista dinamica.
*/
public class Llista {
  private NodeLlista prim, ant;
  private int elements=0;  // Nombre d'elements que tenim

  public Llista() throws NoMemoria {
    NodeLlista aux;
    
    try {
      aux = new NodeLlista();    // Creaci del fantasma
    } catch (OutOfMemoryError e) {
      throw new NoMemoria();
    }

    aux.seguent(null);
    this.prim = aux;
    this.ant = aux;
  }

  public void insertar (Object o) throws NoMemoria {
    NodeLlista PDI;
    NodeLlista aux = new NodeLlista();

    if (aux == null) {
      throw new NoMemoria();
    } else {
      aux.info(o);
      PDI = this.ant.seguent();
      this.ant.seguent(aux);
      aux.seguent(PDI);
      this.ant = aux;
    }
    elements++;
  }

  public void esborrar() throws PDIdreta {
    NodeLlista PDI;

    PDI = this.ant.seguent();
    if (PDI == null) {
      throw new PDIdreta ();
    } else {
      this.ant.seguent (PDI.seguent());
    }
    elements--;
  }

  public Object actual() throws PDIdreta {
    NodeLlista PDI;

    PDI = this.ant.seguent();
    if (PDI == null) {
      throw new PDIdreta();
    } else{
      return PDI.info();
    }
  }

  public boolean buida() {
    return (this.prim.seguent() == null);
  }

  public void principi() {
    this.ant = this.prim;
  }

  public void avanzar() throws PDIdreta {
    NodeLlista PDI;
    PDI = this.ant.seguent();
    
    if (PDI == null) {
      throw new PDIdreta();
    } else {
      this.ant = PDI;
    }
  }

  // Avana n posicions a partir de la posici actual
  public void avanzar(int pos) throws PDIdreta {
    NodeLlista PDI;
    PDI = this.ant.seguent();
    
    for (int i=0; i<pos; i++) {
      if (PDI == null) {
        throw new PDIdreta();
      } else {
        this.ant = PDI;
      }
      PDI = this.ant.seguent();
    }
  }

  public void anarAlFinal() throws PDIdreta {
    while (!this.finalLlista()) {
      this.avanzar();
    }
  }
  
  public boolean finalLlista() {
    return (this.ant.seguent() == null);
  }

  // Retorna el nombre d'elements que tenim
  public int elements(){
    return elements;
  }

}
      

