package Risk.Jugador;

import Risk.Risk;
import Risk.Internals.Exceptions.*;

/**
* Tipus Jugador. Tots els jugador que s'implementin han d'heredar d'aquest.
*/
public abstract class Jugador{
  protected Risk World;

  /**
  * Per evitar problemes al carregar aquesta classe dinamicament, assignem
  * a World un objecte de tipus Risk mitjanant aquest mtode i no en el constructor.
  * Es imprescindible cridar aquesta funci abans de fer s de la resta.
  */
  public abstract void assignWorld(Risk World);
  
  public abstract int Assignment() throws PDIdreta, NoExisteix;
  public abstract int Placement() throws PDIdreta, NoExisteix;
  public abstract AttackResult Attack() throws PDIdreta, NoExisteix, JaExisteix;
  public abstract OccupaResult Occupation(AttackResult attacked) throws PDIdreta, NoExisteix;
  public abstract OccupaResult Fortification() throws PDIdreta, NoExisteix;
  
}