import java.util.Properties;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import Risk.Internals.Mapa;
import Risk.*;
import Risk.Jugador.*;
import Risk.Internals.Exceptions.*;

public class Test{
  
  public static void main(String args[]) throws NoMemoria, PDIdreta, NoExisteix,
      JaExisteix, NoConnexio, JaConectats, NodesIguals,  FileNotFoundException, 
      IOException, ClassNotFoundException, InstantiationException, IllegalAccessException,
      NoTorn, FromTo {

    Properties propietats = new Properties();
    
    /* CODI PER GUARDAR PROPERTIES
    
    propietats.setProperty("Jugador1", "Simple");
    propietats.setProperty("Jugador2", "Rambo");
    FileOutputStream f = new FileOutputStream("players.txt");
    propietats.store(f, "jRisk Players");
    
    */
    
    // Carreguem arxiu de configuraci amb el nom dels 2 jugadors que hem de carregar
    FileInputStream f = new FileInputStream("players.txt");
    propietats.load(f);
    
    
    // Creaci del mapa
    Mapa m = new Mapa();
    // Creaci de la classe que proporciona noms acces als metodes de consulta
    // del mapa. Aquest ser el que dispondran el Jugadors.
    Risk r = new Risk(m);
    

    // Carrega dinmica dels Jugadors
    Jugador j1 = (Jugador)Class.forName(propietats.getProperty("Jugador1")).newInstance();
    Jugador j2 = (Jugador)Class.forName(propietats.getProperty("Jugador2")).newInstance();
    
    // Fem l'assignaci del Risk que han d'utilitzar a traves d'un mtode i no
    // a traves del constructor per evitar complicacions a l'hora de fer la crrega
    // dinmica.
    j1.assignWorld(r);
    j2.assignWorld(r);

    // Afegim els Jugadors al mapa
    m.afegirJugador(propietats.getProperty("Jugador1"));
    m.afegirJugador(propietats.getProperty("Jugador2"));
    m.torn(1);  // Assignem primer torn al primer Jugador
    
    // Continents
    m.afegirContinent("America"); // ID 1
    m.afegirContinent("Europa"); // ID 2
    m.afegirContinent("Asia"); // ID 3
    m.afegirContinent("Africa"); // ID 4
    
    // Continents que fan frontera
    m.afegirContinentBorder("America", "Europa");
    m.afegirContinentBorder("Europa", "Asia");
    m.afegirContinentBorder("Europa", "Africa");
    
    // Afegim els territoris amb el continent al que pertanyen (ID)
    m.afegirTerritori("Alaska", 1);
    m.afegirTerritori("Northwest Territory", 1);
    m.afegirTerritori("Greenland", 1);
    m.afegirTerritori("Alberta", 1);
    m.afegirTerritori("Ontario", 1);
    m.afegirTerritori("Quedec", 1);
    m.afegirTerritori("Western US", 1);
    m.afegirTerritori("Eastern US", 1);
    m.afegirTerritori("Central America", 1);
    m.afegirTerritori("Venezuela", 1);
    m.afegirTerritori("Peru", 1);
    m.afegirTerritori("Brazil", 1);
    m.afegirTerritori("Argentina", 1);
    m.afegirTerritori("North Africa", 1);
    m.afegirTerritori("Egypt", 4);
    m.afegirTerritori("East Africa", 4);
    m.afegirTerritori("Congo", 4);
    m.afegirTerritori("South Africa", 4);
    m.afegirTerritori("Madagascar", 4);
    m.afegirTerritori("Iceland", 2);
    m.afegirTerritori("Scandinavia", 2);
    m.afegirTerritori("Ukraine", 3);
    m.afegirTerritori("Northen Europe", 2);
    m.afegirTerritori("Great Britain", 2);
    m.afegirTerritori("Western Europe", 2);
    m.afegirTerritori("Southern Europe", 2);
    m.afegirTerritori("Middle East", 3);
    m.afegirTerritori("Yamal-Nemets", 3);
    m.afegirTerritori("Kazakhstan", 3);
    m.afegirTerritori("India", 3);
    m.afegirTerritori("Siam", 3);
    m.afegirTerritori("China", 3);
    m.afegirTerritori("Mongolia", 3);
    m.afegirTerritori("Taymyr", 3);
    m.afegirTerritori("Yakut", 3);
    m.afegirTerritori("Buryat", 3);
    m.afegirTerritori("Koryak", 3);
    m.afegirTerritori("Japan", 3);
    m.afegirTerritori("Indonesia", 3);
    m.afegirTerritori("Western Australia", 3);
    m.afegirTerritori("Eastern Australia", 3);
    m.afegirTerritori("New Guinea", 3);
    
    // Afegim les fronteres entre Territoris
    m.afegirTerritoryBorder("Alaska", "Northwest Territory");
    m.afegirTerritoryBorder("Alaska", "Greenland");
    m.afegirTerritoryBorder("Alaska", "Alberta");
    m.afegirTerritoryBorder("Alberta", "Ontario");
    m.afegirTerritoryBorder("Ontario", "Quedec");
    m.afegirTerritoryBorder("Quedec", "Western US");
    m.afegirTerritoryBorder("Western US", "Eastern US");
    m.afegirTerritoryBorder("Western US", "Central America");
    m.afegirTerritoryBorder("Eastern US", "Central America");
    m.afegirTerritoryBorder("Central America", "Venezuela");
    m.afegirTerritoryBorder("Venezuela", "Peru");
    m.afegirTerritoryBorder("Peru", "Brazil");
    m.afegirTerritoryBorder("Brazil", "Argentina");
    m.afegirTerritoryBorder("Argentina", "North Africa");
    m.afegirTerritoryBorder("North Africa", "Egypt");
    m.afegirTerritoryBorder("Egypt", "East Africa");
    m.afegirTerritoryBorder("East Africa", "Congo");
    m.afegirTerritoryBorder("Congo", "South Africa");
    m.afegirTerritoryBorder("South Africa", "Madagascar");
    m.afegirTerritoryBorder("Madagascar", "Iceland");
    m.afegirTerritoryBorder("Iceland", "Scandinavia");
    m.afegirTerritoryBorder("Ukraine", "Northen Europe");
    m.afegirTerritoryBorder("Scandinavia", "Ukraine");
    m.afegirTerritoryBorder("Northen Europe", "Great Britain");
    m.afegirTerritoryBorder("Western Europe", "Northen Europe");
    m.afegirTerritoryBorder("Southern Europe", "Western Europe");
    m.afegirTerritoryBorder("Northen Europe", "Middle East");
    m.afegirTerritoryBorder("Middle East", "Yamal-Nemets");
    m.afegirTerritoryBorder("Yamal-Nemets", "Kazakhstan");
    m.afegirTerritoryBorder("Kazakhstan", "India");
    m.afegirTerritoryBorder("India", "Siam");
    m.afegirTerritoryBorder("Siam", "China");
    m.afegirTerritoryBorder("China", "Mongolia");
    m.afegirTerritoryBorder("Mongolia", "Taymyr");
    m.afegirTerritoryBorder("Yakut", "Buryat");
    m.afegirTerritoryBorder("Buryat", "Koryak");
    m.afegirTerritoryBorder("Koryak", "Japan");
    m.afegirTerritoryBorder("Koryak", "Indonesia");
    m.afegirTerritoryBorder("Indonesia", "Western Australia");
    m.afegirTerritoryBorder("Western Australia", "Eastern Australia");
    m.afegirTerritoryBorder("Eastern Australia", "New Guinea");
    
    // Ja esta construit el Mapa. Es pot iniciar el Joc.
    
    // Assignaci del territori
    System.out.println("******** ASSIGNMENT ********");
    int z;
    for (int i=1; i<22; i++) {  // Son 42 territoris entre 2 = 21
      z=j1.Assignment();
      System.out.println("Jugador " + r.PName(m.torn()) + " es situa a " + r.TName(z));
      m.assign(z);
      m.tornSeguent();

      z=j2.Assignment();
      System.out.println("Jugador " + r.PName(m.torn()) + " es situa a " + r.TName(z));
      m.assign(z);
      m.tornSeguent();
    }
    
    // Fem 10 rotacions i parem
    for (int j=1; j<10; j++) {
      // Placement
      System.out.println("******** PLACEMENT ********");
      int pl;
      for (int i=1; i<m.armiesNum(); i++) {
        pl = j1.Placement();
        System.out.println("Jugador " + r.PName(m.torn()) + " posa army a " + r.TName(pl));
        m.place(pl);
        m.tornSeguent();
        
        pl = j2.Placement();
        System.out.println("Jugador " + r.PName(m.torn()) + " posa army a " + r.TName(pl));
        m.place(pl);
        m.tornSeguent();
        
        m.restarArmiesPendents(); // Util per PNewArmies
      }
      m.resetArmiesPendents(); // Util per PNewArmies
      
      AttackResult a;
      OccupaResult o;
      // Attack
      System.out.println("******** ATTACK ********");
      for (int i=1; i<3; i++) {
        a = j1.Attack();
        // Si retorna 0 al From vol dir que passa el torn
        while (a.GetFrom() != 0) {
          
          System.out.println("Jugador " + r.PName(m.torn()) + " ataca des de " + 
            r.TName(a.GetFrom())  + " a " + r.TName(a.GetTo()));
          
          if (m.attack(a)) {  // Si ha conquistat
            o = j1.Occupation(a);
            System.out.println("Jugador " + r.PName(m.torn()) + " CONQUISTA! i mou des de " +
              r.TName(o.GetFrom())  + " a " + r.TName(o.GetTo()) + " " + o.GetNumArmies() +
              " armies");
            m.occupation(o);
          }
          
          a = j1.Attack();
        }
        m.tornSeguent();
        
        a = j2.Attack();
        // Si retorna 0 al From vol dir que passa el torn
        while (a.GetFrom() != 0) {
          System.out.println("Jugador " + r.PName(m.torn()) + " ataca des de " + r.TName(a.GetFrom())
            + " a " + r.TName(a.GetTo()));
            
          if (m.attack(a)) {  // Si ha conquistat
            o = j2.Occupation(a);
            System.out.println("Jugador " + r.PName(m.torn()) + " CONQUISTA! i mou des de " +
              r.TName(o.GetFrom())  + " a " + r.TName(o.GetTo()) + " " + o.GetNumArmies() +
              " armies");
            m.occupation(o);
          }

          a = j2.Attack();
        }
        m.tornSeguent();
        
      }
      
      
      // Fortification
      System.out.println("******** FORTIFICATION ********");
      o = j1.Fortification();
      // Si retorna 0 al From vol dir que passa el torn
      while (o.GetFrom() != 0) {
        System.out.println("Jugador " + r.PName(m.torn()) + " fortifica des de " + r.TName(o.GetFrom()) +
          " a " + r.TName(o.GetTo()) + " amb " + o.GetNumArmies()); 
        m.occupation(o);
        o = j1.Fortification();
      }
      m.tornSeguent();
      
      o = j2.Fortification();
      // Si retorna 0 al From vol dir que passa el torn
      while (o.GetFrom() != 0) {
        System.out.println("Jugador " + r.PName(m.torn()) + " fortifica des de " + r.TName(o.GetFrom()) +
          " a " + r.TName(o.GetTo()) + " amb " + o.GetNumArmies());
        m.occupation(o);
        o = j2.Fortification();
      }
      m.tornSeguent();
    }
    

  }
}
